Description

casecmp method doesn't work with Unicode symbol - https://bugs.ruby-lang.org/issues/14055

decision is to use casecmp? instead of casecmp - https://bugs.ruby-lang.org/issues/12786

Related issues:

Related to Redmine - Patch #20369: Use String#casecmp for case insensitive co... Closed

Related to Redmine - Defect #30441: Attachments with Unicode uppercase names ... Closed

Related to Redmine - Feature #34142: Drop Ruby 2.3 support Closed

Associated revisions

Revision 20835 - 2021-03-21 00:29 - Go MAEDA

Case-insensitive matching fails for Unicode filenames when referring to attachments in text formatting (#27780).

Patch by Go MAEDA.

History

#1 - 2017-12-11 17:52 - Toshi MARUYAMA

- Tracker changed from Patch to Defect

- Subject changed from Attachment.rb patch to Attachment sort doesn't work with Unicode

#2 - 2017-12-11 17:58 - Toshi MARUYAMA

Could you add test?

source:trunk/test/unit/attachment_test.rb@17111#L386

#3 - 2017-12-12 03:24 - Go MAEDA

Амир Мусин, thank you for reporting the problem and providing the patch.

But the patch needs some improvements because Ruby older than 2.4 don't have casecmp? (https://github.com/ruby/ruby/blob/v2_4_0/NEWS). The

upcoming Redmine 4.0.0 supports Ruby 2.2.2 and later (#25538).

#4 - 2017-12-12 04:07 - Go MAEDA

- Related to Patch #20369: Use String#casecmp for case insensitive comparison added

#5 - 2018-11-06 04:00 - Go MAEDA

- Target version set to Candidate for next major release

We can merge this patch if Redmine migrates to Rails 6 (maybe in Redmine 5?).

Rails 6 requires Ruby 2.4.1+ by jeremy · Pull Request #32034 · rails/rails

#6 - 2018-11-06 04:07 - Go MAEDA

- Related to Feature #29914: Migrate to Rails 6.1 with Zeitwerk autoloading added

#7 - 2019-04-02 18:02 - Go MAEDA

- Related to Defect #30441: Attachments with Unicode uppercase names are not shown in wiki pages added
#8 - 2019-04-13 05:50 - Go MAEDA

Go MAEDA wrote:

But the patch needs some improvements because Ruby older than 2.4 don't have casecmp? (https://github.com/ruby/ruby/blob/v2_4_0/NEWS).

The upcoming Redmine 4.0.0 supports Ruby 2.2.2 and later (#25538).

 We can apply the patch provided by Амир Мусин and fix the issue for Ruby >=2.4 right now if we define String#casecmp? method like the following.

Even if we define the method, the problem will not fe fixed under Ruby 2.3 because the fake String#casecmp? is not Unicode-aware unlike the

genuine String#casecmp?. But I think it is OK because the Ruby team has ended support for 2.3 last month and probably many people who use the

latest version of Redmine don't use such old Ruby.

We can delete the definition when Redmine has dropped the support for Ruby 2.3.

diff --git a/config/initializers/10-patches.rb b/config/initializers/10-patches.rb

index e0559903b..0154de257 100644

--- a/config/initializers/10-patches.rb

+++ b/config/initializers/10-patches.rb

@@ -213,3 +213,12 @@ module ActionView

     end

   end

 end

+

+if RUBY_VERSION < '2.4'

+  class String

+    # bahaves like String#casecmp? but does not support Unicode

+    def casecmp?(other)

+      self.casecmp(other).zero?

+    end

+  end

+end

#9 - 2020-10-21 04:48 - Go MAEDA

- Related to deleted (Feature #29914: Migrate to Rails 6.1 with Zeitwerk autoloading)

#10 - 2020-10-21 04:48 - Go MAEDA

- Related to Feature #34142: Drop Ruby 2.3 support added

#11 - 2020-10-21 04:52 - Go MAEDA

Go MAEDA wrote:

Go MAEDA wrote:

But the patch needs some improvements because Ruby older than 2.4 don't have casecmp? (

https://github.com/ruby/ruby/blob/v2_4_0/NEWS). The upcoming Redmine 4.0.0 supports Ruby 2.2.2 and later (#25538).

 We can apply the patch provided by Амир Мусин and fix the issue for Ruby >=2.4 right now if we define String#casecmp? method like the

following.

 It is not necessary now because the trunk dropped support for Ruby 2.3 (#34142).

#12 - 2020-10-22 16:30 - Go MAEDA

- File 27780.patch added

Added test code to Амир Мусин's patch.

#13 - 2020-10-23 00:04 - Go MAEDA

- Target version changed from Candidate for next major release to 4.2.0

Setting the target version to 4.2.0.

#14 - 2021-03-18 20:24 - Marius BĂLTEANU

Looks good to me.
#15 - 2021-03-21 00:29 - Go MAEDA

- Subject changed from Attachment sort doesn't work with Unicode to Case-insensitive matching fails for Unicode filenames when referring to

attachments in text formatting

- Category changed from Attachments to Text formatting

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the fix.

Files

attachment.rb.patch 404 Bytes 2017-12-11 Амир Мусин

27780.patch 1.29 KB 2020-10-22 Go MAEDA

Powered by TCPDF (www.tcpdf.org)

2025-05-01 3/3

http://www.tcpdf.org

